mod Ex07a

incl Mtex

incl Mtexrc

incl Mauxa

loc rem 
  \para \bf  7. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end nedeľa 5.4.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované primitívne 
  rekurzívnym funkciam a univerzálnej funkcii pre primitívne rekurzívne 
  funkcie. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 2 
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 1 
  \end
  \para Odovzdať do 10.4.2020 (piatok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Ján Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
   \item \para \it  [3]  \end Ján Komara. Recursive Functions. Online. 
  \end

rem 
  \para \bf  Remark.  \end The abbreviation \it  p.r.  \end stands for \it  
  primitive recursive.  \end 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Basic primitive recursive functions.  \end See also the module \it  
  Maux*  \end. 

rem 
  \para \bf  Composition.  \end 

rem 
  \para \bf  Primitive recursion.  \end 

rem 
  \para \bf  Primitive recursive functions.  \end 

rem 
  \para \bf  Example.  \end Find a p.r. derivation of the ternary function 
  \eq* 
    Tex_f3_h(x,z,y) = z+1
  \end

fun/3 H_plus 'Tex_f3_h'
  H_plus(x,z,y) = Ss I_3_2(x,z,y)

rem 
  \para \bf  Addition is primitive recursive.  \end Find a p.r. derivation of 
  the addition function \ft x+y \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    0+y = y
  \end
  \eq* 
    x+1+y = x+y+1
  \end

fun/2 Plus 'Tex_f2_n_plus'
  Plus(0,y) = I(y)
  Plus(Ss(x),y) = H_plus(x,Plus(x,y),y)

rem 
  \para \bf  Subsection. Exercises.  \end 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a p.r. derivation of the 
  multiplication function \ft x*y \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    0*y = 0
  \end
  \eq* 
    (x+1)*y = x*y+y
  \end

fun/3 H_times 'Tex_f3_h'
  H_times(x,z,y) = Foo

fun/2 Times 'Tex_f2_n_times'
  Times(0,y) = Foo
  Times(Ss(x),y) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a p.r. derivation of the 
  exponentiation function \ft Tex_f2_n_exp(x,y) \end. 
  \para \it  Hint.  \end Recall that 
  \eq* 
    Tex_f2_n_exp(x,0) = 1
  \end
  \eq* 
    Tex_f2_n_exp(x,y+1) = x*Tex_f2_n_exp(x,y)
  \end
  \para Rewrite the recurrences for the binary function 
  \eq* 
    Tex_f2_f(y,x) = Tex_f2_n_exp(x,y)
  \end

fun C1 
  C1(x) = Foo

fun/3 H_exp1 'Tex_f3_h'
  H_exp1(y,z,x) = Foo

fun/2 Exp1 'Tex_f2_f'
  Exp1(0,x) = Foo
  Exp1(Ss(y),x) = Foo

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Subsection. Additional Problems.  \end 

rem 
  \para \bf  Exercise. \it  (1 bonus point)  \end  \end Find a 'short' p.r. 
  derivation of the constant function 
  \eq* 
    C256(x) = 256
  \end

fun C256 
  C256(x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

loc rem 
  \para \bf  Some useful queries.  \end 

loc rem 
  Test_fun(x) = Plus(x,2)
  Test_fun(x) = Times(x,2)
  Test_fun(x) = Exp(2,x)
  Test_fun(x) = C256(x)
  
  Itf(5) = test

