mod Ex07b

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Mxpr

incl Mauxb

loc rem 
  \para \bf  7. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end nedeľa 5.4.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované primitívne 
  rekurzívnym funkciam a univerzálnej funkcii pre primitívne rekurzívne 
  funkcie. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 4 
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 0 
  \end
  \para Odovzdať do 10.4.2020 (piatok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Ján Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
   \item \para \it  [3]  \end Ján Komara. Recursive Functions. Online. 
  \end

rem 
  \para \bf  Chapter. General Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Universal Function for 
  Primitive Recursive Functions.  \end 

rem 
  \para \bf  Primitive recursive function symbols.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \it  Mxpr  \end. 

rem 
  \para \bf  Interpreter of primitive recursive function symbols. \it  (2 
  points)  \end  \end Define the interpreter of p.r. function symbols. 

fun/2 Interpreter 'Tex_f2_xpr_interpreter'
  Interpreter(e,x) = Foo

rem 
  \para \bf  Primitive recursive indices.  \end See also the binary predicate 
  \ft Prf(n,e) \end holding of well-formed p.r. indices defined in the module 
  \it  Mxpr  \end. 

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_1 'Tex_f0_xpr_xc1_1' \end Find a 
  well-formed p.r. index of the unary constant function \ft C1(x) = 1 \end, i.e. 
  find the number \ft Xc1_1 \end such that 
  \eq* 
    Prf(1,Xc1_1)
  \end
  \eq* 
    Interpreter(Xc1_1,x) = 1
  \end

fun/0 Xc1_1 'Tex_f0_xpr_xc1_1'
  Xc1_1 = Cx(1,1,Sx,Zx)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xplus 'Tex_f0_xpr_xplus' \end Find a 
  well-formed p.r. index of the addition function \ft x+y \end, i.e. find the 
  number \ft Xplus \end such that 
  \eq* 
    Prf(2,Xplus)
  \end
  \eq* 
    Interpreter(Xplus,x,y) = x+y
  \end

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Rx(2,Ix(1,1),Cx(3,1,Sx,Ix(3,2)))

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xtimes 'Tex_f0_xpr_xtimes' \end Find a well-formed p.r. index 
  of the multiplication function \ft x*y \end, i.e. find the number 
  \ft Xtimes \end such that 
  \eq* 
    Prf(2,Xtimes)
  \end
  \eq* 
    Interpreter(Xtimes,x,y) = x*y
  \end

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xexp 'Tex_f0_xpr_xexp' \end Find a well-formed p.r. index of 
  the exponentiation function \ft Exp(x,y) \end, i.e. find the number 
  \ft Xexp \end such that 
  \eq* 
    Prf(2,Xexp)
  \end
  \eq* 
    Interpreter(Xexp,x,y) = Exp(x,y)
  \end

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  Test_fun(x) = Interpreter(Xplus,x,2)
  Test_fun(x) = Interpreter(Xtimes,x,2)
  Test_fun(x) = Interpreter(Xexp,2,x)
  
  Itf(5) = test

